// pages/webview/webview.js
import { routers, viewImage, sharePage, isFn } from '../../utils/util.js'
const { navigateTo, redirectTo, navigateBack } = routers()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    canIUseWebview: wx.canIUse('web-view'),
    isLoaded: 0
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const { title = '' } = options
    if (title) {
      wx.setNavigationBarTitle({ title })
    }
    this.setData({ options, isLoaded: 1 })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    const obj = { navigateTo, redirectTo, navigateBack, viewImage }
    for (const i in obj) {
      this[i] = obj[i]
    }
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    if (isFn(sharePage)) return sharePage()
  }
})