// parents/pages/reservations/reservations.js
import { routers, viewImage, sharePage, isFn, getGlobalVal } from '../../../utils/util.js'
import { BorrowInfoList } from '../../../utils/api.js'
const { navigateTo, redirectTo, navigateBack } = routers()
const { globalData, hasLibraryService, hasVipService } = getApp()
const { baseImgUrl, qrcodeInvalidToastText } = globalData

Page({

  /**
   * 页面的初始数据
   */
  data: {
    baseImgUrl,
    isLoaded: 1,
    content: '',
    navIndex: 0,
    pageNo:1,
    pageSize:10,
    isAll:0,
    list:[],
    navList: [
      {
        text: '借阅中',
        list: [],
        nodataArray: {
          text: '暂没有预约书单',
          image: '../../../assets/nodata_3.png',
          hasNodataBtn: 1,
          btnText: '去书库看看'
        }
      },
      {
        text: '已归还',
        list: [],
        nodataArray: {
          text: '暂没有已预约书单',
          image: '../../../assets/nodata_2.png',
          hasNodataBtn: 1,
          btnText: '去书库看看'
        }
      }
    ]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    // if(options.vipId)
    // options.vipId = getGlobalVal('vipId', `vipId_${getGlobalVal('userId')}`) || ''
    // // options.vipId = '306330bd-5c8c-41aa-8a00-0f0c296ebb29',
    // options.libId = getGlobalVal('library').id || ''
    // console.log(options)
    this.setData({ options })
    this.getData(res => {
      this.setData({ isLoaded: 1 })
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    const obj = { navigateTo, redirectTo, navigateBack, viewImage }
    for (const i in obj) {
      this[i] = obj[i]
    }
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
  * 页面相关事件处理函数--监听用户下拉动作
  */
  onPullDownRefresh: function () {
    const { isAll, options } = this.data
    const { type = 1 } = options
    if (type == 1) return
    this.setData({ pageNo: 1 })
    this.getData(res => {
      wx.stopPullDownRefresh()
    })
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    const { isAll, options } = this.data
    const { type = 1 } = options
    if (type == 1 || isAll) return
    this.getData()
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    if (isFn(sharePage)) return sharePage()
  },

  /**
   * 获取数据
   */
  getData: function (cb) {
    const continuousFn = { fn: this.getData, param: { ...arguments } }
    var that=this
    const { navIndex, navList, options, pageSize, pageNo,type } = this.data
    const { vipId, libId } = options
    BorrowInfoList({ data: { pageSize, pageNo, vipId, libId, type: navIndex+1}, continuousFn }).then(res => {
      const { list } = res.data
      const oneTemp = (res => {
        for (let i in res) {
          for (let j in res[i].valueList){
            if (res[i].valueList[j].summary){
              if (res[i].valueList[j].summary.length > 30) {
                res[i].valueList[j].summary = res[i].valueList[j].summary.slice(0, 30) + '...'
                } else {
                res[i].valueList[j].summary = res[i].valueList[j].summary
                }
            }
          }
        }
        return res
      })(list)
      
      let listTemp = []
      if (pageNo == 1) {
        listTemp = [].concat(oneTemp)
      } else {
        listTemp = [].concat(that.data.list, oneTemp)
      }
      this.setData({ 
        list: listTemp, 
        pageNo: list.length == pageSize ? pageNo + 1 : pageNo, 
        isAll: list.length < pageSize 
      })
      cb && cb()
    }).catch(res => {
      cb && cb()
    })
  },
  /**
   * 选择导航栏
   */
  selectNavCtl: function (e) {
    const { index } = e.currentTarget.dataset
    const { navIndex, navList } = this.data
    if (navIndex == index) return
    this.setData({ navIndex: index })
    if (index == 0) {
      if (navList[index]['list'].length == 0) {
        this.getData()
      }
    } else if (index == 1) {
      this.getData()
    }
  },
})