
import { routers, viewImage, sharePage, isFn, getGlobalVal } from '../../../utils/util.js'
import { ApplyBookHis, ApplyInfoList, ApplyInfoDetailList } from '../../../utils/api.js'
const { navigateTo, redirectTo, navigateBack } = routers()
const { globalData } = getApp()
const { baseImgUrl, thumbnail } = globalData
Page({

  /**
   * 页面的初始数据
   */
  data: {
    baseImgUrl,
    thumbnail,
    isLoaded: 0,
    isShowBooklists:0,
    title: '',
    pageNo: 1,
    pageSize: 10,
    isAll: false,
    navIndex: 0,
    booksId:'',
    list: [],
    ApplyInfoList:[],
    pageNoApply: 1,
    pageSizeApply: 10,
    isAllCheck: 0,
    isManage: 0,
    totalNum: 0,
    isDelete: false,
    nodataArray: {
      text: "暂无历史记录",
      image: '../../../assets/nodata_3.png',
    }
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    options.vipId = getGlobalVal('vipId', `vipId_${getGlobalVal('userId')}`) || ''
    options.libId = getGlobalVal('list').length > 0 ? getGlobalVal('list')[0].libId : ''
    wx.setNavigationBarTitle({
      title: `调书申请记录`,
    })
    this.setData(options)
    this.getData(res => {
      this.setData({ isLoaded: 1 })
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    const obj = { navigateTo, redirectTo, navigateBack, viewImage }
    for (const i in obj) {
      this[i] = obj[i]
    }
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },


  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
  * 页面相关事件处理函数--监听用户下拉动作
  */
  onPullDownRefresh: function () {
    const { isShowBooklists } = this.data
    this.setData({ pageNo: 1, pageNoApply: 1 })
    if (isShowBooklists == 0) {
      this.getData(res => {
        wx.stopPullDownRefresh()
      })
    }
    if (isShowBooklists == 1) {
      this.getApplyInfoData(res => {
        wx.stopPullDownRefresh()
      })
    }

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    const { isAll, isDown, isShowBooklists } = this.data
    if (isAll) {
      this.setData({ isDown: true })
      return
    } else {
      this.setData({ isLoad: true, isDown: false })
      if (isShowBooklists == 0) {
        this.getData(() => {
          this.setData({ isLoad: false })
        })
      }
      if (isShowBooklists == 1) {
        this.getApplyInfoData(() => {
          this.setData({ isLoad: false })
        })
      }

    }
  },
  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    if (isFn(sharePage)) return sharePage()
  },
    /**
 * 查看调书申请明细记录
 */
  booklistInfo: function (e) {
    const { id } = e.currentTarget.dataset
    this.setData({ isShowBooklists: 1, booksId: id })
    this.getApplyInfoData()
  },
  /**
 * 调书申请记录
 */
  getData: function (cb) {
    const continuousFn = { fn: this.getData, param: { ...arguments } }
    const { pageNo, pageSize, libId, list = [] } = this.data
    ApplyInfoList({ data: { libId, pageNo, pageSize,}, continuousFn }).then(res => {
      const { list } = res.data
      let listTemp = []
      if (pageNo == 1) {
        listTemp = [].concat(list)
      } else {
        listTemp = [].concat(this.data.list, list)
      }
      // console.log(listTemp)
      this.setData({ list: listTemp, pageNo: list.length == pageSize ? pageNo + 1 : pageNo, isAll: list.length < pageSize })
      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },
  /**
 * 调书申请明细记录
 */
  getApplyInfoData: function (cb) {
    const continuousFn = { fn: this.getData, param: { ...arguments } }
    const { pageNoApply, pageSizeApply, booksId, ApplyInfoList = [] } = this.data
    ApplyInfoDetailList({ data: { id: booksId, pageNo: pageNoApply, pageSize: pageSizeApply, }, continuousFn }).then(res => {
      const { list } = res.data
      let listTemp = []
      if (pageNoApply == 1) {
        listTemp = [].concat(list)
      } else {
        listTemp = [].concat(this.data.ApplyInfoList, list)
      }
      console.log(listTemp)
      this.setData({ ApplyInfoList: listTemp, pageNoApply: ApplyInfoList.length == pageSizeApply ? pageNoApply + 1 : pageNoApply, isAll: ApplyInfoList.length < pageSizeApply })

      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },

})

