// parents/pages/reservations/reservations.js
import { routers, viewImage, sharePage, isFn, getGlobalVal } from '../../../utils/util.js'
import { ReadingBorrowInfoList, CallBookBack } from '../../../utils/api.js'
const { navigateTo, redirectTo, navigateBack } = routers()
const { globalData, hasLibraryService, hasVipService } = getApp()
const { baseImgUrl, qrcodeInvalidToastText } = globalData

Page({

  /**
   * 页面的初始数据
   */
  data: {
    baseImgUrl,
    isLoaded: 1,
    content: '',
    navIndex: 0,
    pageNo:1,
    pageSize:10,
    isDown: false,
    objectIndex:0,
    arryIndex:0,
    isAll:0,
    timearray: [
      {
        type: 1,
        name: '未过期'
      },
      {
        type: 2,
        name: '已过期'
      },
    ],
    nearytimearray: [
      {
        type: 3,
        name: '近7天数据'
      },
      {
        type: 4,
        name: '近30天数据'
      },
      {
        type: 5,
        name: '近180天数据'
      },
    ],
    index: 0,
    state:1,
    type:1,
    list:[],
    isreturn:0,
    navList: [
      {
        text: '借阅中',
        list: [],
        nodataArray: {
          text: '暂无外借中书籍',
          image: '../../../assets/nodata_1.png',
         
        }
      },
      {
        text: '已归还',
        list: [],
        nodataArray: {
          text: '无已归还记录',
          image: '../../../assets/nodata_1.png',
        }
      }
    ],
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    console.log(options)
    // options.vipId = getGlobalVal('vipId', `vipId_${getGlobalVal('userId')}`) || ''
    // options.libId = getGlobalVal('list').length > 0 ? getGlobalVal('list')[0].libId : ''
    this.setData(options)
    this.getData(res => {
      this.setData({ isLoaded: 1 })
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    const obj = { navigateTo, redirectTo, navigateBack, viewImage }
    for (const i in obj) {
      this[i] = obj[i]
    }
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
  * 页面相关事件处理函数--监听用户下拉动作
  */
  onPullDownRefresh: function () {
   
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    const { isAll, isDown } = this.data
    if (isAll) {
      this.setData({ isDown: true })
      return
    } else {
      this.setData({ isLoad: true, isDown: false })
      this.getData(() => {
        this.setData({ isLoad: false })
      })
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    if (isFn(sharePage)) return sharePage()
  },
  pickChange: function (e) {
    const { pageNo, isDown} = this.data
    const { value } = e.detail
    this.setData({ 'type': ~~value + 1, arryIndex: ~~value, pageNo: 1, isDown:false })
    this.getData()
  },
  timepickChange: function (e) {
    const { pageNo, isDown } = this.data
    const { value } = e.detail
    this.setData({ 'type': ~~value + 3, objectIndex: ~~value, pageNo: 1, isDown: false })
    this.getData()
  },
  /**
   * 获取数据
   */

  getData: function (cb) {
    const continuousFn = { fn: this.getData, param: { ...arguments } }
    const { navIndex, navList, options, pageSize, pageNo, type, state, libId } = this.data
    ReadingBorrowInfoList({ data: { pageSize, pageNo, libId, state: navIndex + 1, type }, continuousFn }).then(res => {
      const { list, totalSize } = res.data
      let listTemp = []
      if (pageNo == 1) {
        listTemp = [].concat(list)
      } else {
        listTemp = [].concat(this.data.list, list)
      }
      const correctListTemp = (res => {
        console.log(res)
        var d = []
        for (let i in res) {
          res[i].number = 0
        }
        return res
      })(listTemp)
      this.setData({ list: correctListTemp, totalNumbers: totalSize, pageNo: list.length == pageSize ? pageNo + 1 : pageNo, isAll: list.length < pageSize })
      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },
  /**
   * 选择导航栏
   */
  selectNavCtl: function (e) {
    const { index } = e.currentTarget.dataset
    const { navIndex, navList, list, pageNo, isDown, isreturn } = this.data
    if (navIndex == index) return
    this.setData({ navIndex: index, list: [], pageNo: 1, isDown: false })
    if (index == 0) {
      this.setData({ isreturn: 0 })
      this.setData({ type: 1 })
      if (navList[index]['list'].length == 0) {
        this.getData()
      }
    } else if (index == 1) {
      this.setData({ type:3 })
      this.setData({ isreturn: 1 })
      this.getData()
    }
  },
   /**
   * 催所有人归还
   */
  UrgeSubmit: function (cb) {
    const continuousFn = { fn: this.UrgeSubmit, param: { ...arguments } }
    const { libId } = this.data
    CallBookBack({ data: {  libId }, continuousFn }).then(res => {
      const { msg } = res
      wx.showToast({
        title: msg,
        icon: 'none'
      })
    })
  },
  
})