// parents/pages/reservations/reservations.js
import { routers, viewImage, sharePage, isFn, getGlobalVal } from '../../../utils/util.js'
import { BorrowInfoList } from '../../../utils/api.js'
const { navigateTo, redirectTo, navigateBack } = routers()
const { globalData, hasLibraryService, hasVipService } = getApp()
const { baseImgUrl, thumbnail,qrcodeInvalidToastText } = globalData

Page({

  /**
   * 页面的初始数据
   */
  data: {
    baseImgUrl,
    thumbnail,
    isLoaded: 1,
    content: '',
    navIndex: 0,
    pageNo:1,
    pageSize:10,
    user_vipId:'',
    isAll:0,
    isDown: false,
    list:[],
    navList: [
      {
        text: '借阅中',
        list: [],
        nodataArray: {
          text: '暂没有预约书单',
          image: '../../../assets/nodata_3.png',
          hasNodataBtn: 1,
          btnText: '去书库看看'
        }
      },
      {
        text: '已归还',
        list: [],
        nodataArray: {
          text: '暂没有已预约书单',
          image: '../../../assets/nodata_2.png',
          hasNodataBtn: 1,
          btnText: '去书库看看'
        }
      }
    ]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    const user_vipId = wx.getStorageSync("vipId")
    this.setData({
      user_vipId: user_vipId
    });
    options.vipId = getGlobalVal('vipId', `vipId_${getGlobalVal('userId')}`) || ''
    options.libId = getGlobalVal('list').length > 0 ? getGlobalVal('list')[0].libId : ''
    wx.setNavigationBarTitle({
      title: `借阅记录`,
    })
    this.setData(options)
    this.getData(res => {
      this.setData({ isLoaded: 1 })
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    const obj = { navigateTo, redirectTo, navigateBack, viewImage }
    for (const i in obj) {
      this[i] = obj[i]
    }
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
  * 页面相关事件处理函数--监听用户下拉动作
  */
  onPullDownRefresh: function () {
    const { isAll, options } = this.data
    const { type = 1 } = options
    if (type == 1) return
    this.setData({ pageNo: 1 })
    this.getData(res => {
      wx.stopPullDownRefresh()
    })
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    const { isAll, isDown } = this.data
    if (isAll) {
      this.setData({ isDown: true })
      return
    } else {
      this.setData({ isLoad: true, isDown: false })
      this.getData(() => {
        this.setData({ isLoad: false })
      })
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    if (isFn(sharePage)) return sharePage()
  },

  /**
   * 获取数据
   */
  getData: function (cb) {
    const continuousFn = { fn: this.getData, param: { ...arguments } }
    // if (!hasVipService()) {
    //   cb && cb()
    //   return
    // }
    // if (!hasLibraryService()) {
    //   cb && cb()
    //   return
    // }
    const { navIndex, navList, options, pageSize, user_vipId, libId, pageNo,type } = this.data
    BorrowInfoList({ data: { pageSize, pageNo, vipId: user_vipId, libId, type: navIndex+1}, continuousFn }).then(res => {
      const { list, pages } = res.data
      let listTemp = []
      if (pageNo == 1) {
        listTemp = [].concat(list)
      } else {
        listTemp = [].concat(this.data.list, list)
      }
      // console.log(listTemp)
      this.setData({ list: listTemp, pages: pages, pageNo: list.length == pageSize ? pageNo + 1 : pageNo, isAll: list.length < pageSize })
      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },
  /**
   * 选择导航栏
   */
  selectNavCtl: function (e) {
    const { index } = e.currentTarget.dataset
    const { navIndex, navList } = this.data
    if (navIndex == index) return
    this.setData({ navIndex: index })
    if (index == 0) {
      if (navList[index]['list'].length == 0) {
        this.getData()
      }
    } else if (index == 1) {
      this.getData()
    }
  },
})