
import { routers, viewImage, sharePage, isFn, getGlobalVal } from '../../../utils/util.js'
import { NewBookApplyDetailList, NewBookApplyInfoList, SearchUserApplyList, BatchCallInBooks} from '../../../utils/api.js'
const { navigateTo, redirectTo, navigateBack } = routers()
const { globalData } = getApp()
const { baseImgUrl, thumbnail } = globalData
Page({

  /**
   * 页面的初始数据
   */
  data: {
    baseImgUrl,
    thumbnail,
    isLoaded: 0,
    isShowBooklists: 0,
    title: '',
    pageNo: 1,
    pageSize: 10,
    isAll: false,
    navIndex: 0,
    booksId: '',
    searchInfoId:'',
    list: [],
    ApplyInfoList:[],
    UserApplyList :[],
    pageNoApply:1, 
    pageSizeApply:10,
    isAllCheck: 0,
    isManage: 0,
    totalNum: 0,
    isDelete: false,
    deleteModel: false,
    selecetAdd: false ,
    pageNoUserApply:1, 
    pageSizeUserApply:10, 
    nodataArray: {
      text: "暂无历史记录",
      image: '../../../assets/nodata_3.png',
      margin: '400rpx auto'
    }
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    options.vipId = getGlobalVal('vipId', `vipId_${getGlobalVal('userId')}`) || ''
    options.libId = getGlobalVal('list').length > 0 ? getGlobalVal('list')[0].libId : ''
    wx.setNavigationBarTitle({
      title: `新书申请记录`,
    })
    this.setData(options)
    if (options.id){
      this.setData({ searchInfoId: options.id || '', isShowBooklists:3 })
      this.getUserApplyList(res => {
        this.setData({ isLoaded: 1 })
      })
    } 
    if (!options.id) {
      this.getData(res => {
        this.setData({ isLoaded: 1 })
      })
    }
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    const obj = { navigateTo, redirectTo, navigateBack, viewImage }
    for (const i in obj) {
      this[i] = obj[i]
    }
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let _this = this
    wx.getStorage({
      key: 'infofrominput',
      success: function (res) {
        _this.setData({
          infofromstorage: res.data,
        })
        console.log(res)
      }
    })

  },

  /**
   * 提示框隐藏
   */
  allShowModel: function () {
    this.setData({ deleteModel: false })
  },
  /**
   * 删除打开
   */
  sureDelete: function (e) {
    const { selecetAdd } = this.data
    const { index } = e.currentTarget.dataset
    this.setData({ deleteModel: true, deleteIndex: index, selecetAdd: !selecetAdd })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    const { isShowBooklists } = this.data
    this.setData({ pageNo: 1, pageNoApply:1 })
    if (isShowBooklists ==0){
      this.getData(res => {
        wx.stopPullDownRefresh()
      })
    }
    if (isShowBooklists == 1) {
      this.getApplyInfoData(res => {
        wx.stopPullDownRefresh()
      })
    }
    
  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    const { isAll, isDown, isShowBooklists } = this.data
    if (isAll) {
      this.setData({ isDown: true })
      return
    } else {
      this.setData({ isLoad: true, isDown: false })
      if (isShowBooklists == 0) {
        this.getData(() => {
          this.setData({ isLoad: false })
        })
      }
      if (isShowBooklists == 1) {
        this.getApplyInfoData(() => {
          this.setData({ isLoad: false })
        })
      }
     
    }
  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    if (isFn(sharePage)) return sharePage()
  },
  /**
* 查看调书申请明细记录
*/
  booklistInfo: function (e) {
    const { id } = e.currentTarget.dataset
    this.setData({ isShowBooklists: 1, booksId: id })
    this.getApplyInfoData()
  },
  /**
 * 新书申请记录
 */
  getData: function (cb) {
    const continuousFn = { fn: this.getData, param: { ...arguments } }
    const { pageNo, pageSize, libId, list = [] } = this.data
    NewBookApplyInfoList({ data: { libId, pageNo, pageSize, }, continuousFn }).then(res => {
      const { list } = res.data
      let listTemp = []
      if (pageNo == 1) {
        listTemp = [].concat(list)
      } else {
        listTemp = [].concat(this.data.list, list)
      }
      // console.log(listTemp)
      this.setData({ list: listTemp, pageNo: list.length == pageSize ? pageNo + 1 : pageNo, isAll: list.length < pageSize })
      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },
  /**
 * 调书申请明细记录
 */
  getApplyInfoData: function (cb) {
    const continuousFn = { fn: this.getApplyInfoData, param: { ...arguments } }
    const { pageNoApply, pageSizeApply, booksId, ApplyInfoList = [] } = this.data
    NewBookApplyDetailList({ data: { id: booksId, pageNo: pageNoApply, pageSize: pageSizeApply, }, continuousFn }).then(res => {
      const { list } = res.data
      let listTemp = []
      if (pageNoApply == 1) {
        listTemp = [].concat(list)
      } else {
        listTemp = [].concat(this.data.ApplyInfoList, list)
      }
      console.log(listTemp)
      this.setData({ ApplyInfoList: listTemp, pageNoApply: ApplyInfoList.length == pageSizeApply ? pageNoApply + 1 : pageNoApply, isAll: ApplyInfoList.length < pageSizeApply })

      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },
    /**
 * 加入到调书清单或申请新书列表
 */
  UrgeSubmit: function (cb){
    const { UserApplyList = [] } = this.data
    const { infofromstorage } = this.data
    const bookList = []
    for (let i = 0; i < UserApplyList.length; i++) {
      if (UserApplyList[i].state == 2) {
        infofromstorage.unshift({ bookImg: UserApplyList[i].bookImg, title: UserApplyList[i].title, publish: '', bookSrc: '', publish: '',paiDate:'',})
        wx.setStorageSync('infofrominput', infofromstorage)
      }
      if (UserApplyList[i].state == 1) {
        bookList.push({
          bookInfoId: UserApplyList[i].bookInfoId,
          isbn13: UserApplyList[i].isbn13
        })
      }
    }
    this.setData({ bookList})
    this.getCallin()
},

  /**
   * 确认调入
   */
  getCallin: function () {
    const continuousFn = { fn: this.getCallin, param: { ...arguments } }
    const { bookList, libId } = this.data
    BatchCallInBooks({ data: { libId, bookList }, continuousFn }).then(res => {
      wx.showToast({
        title: `已加入调入列表`
      })
      this.getUserApplyList()
    })
  },
  /**
 * 公众号模板进入申请书单详情
 */
  getUserApplyList: function (cb) {
    const continuousFn = { fn: this.getUserApplyList, param: { ...arguments } }
    const { pageNoUserApply, pageSizeUserApply, searchInfoId, UserApplyList = [] } = this.data
    SearchUserApplyList({ data: { id: searchInfoId, pageNo: pageNoUserApply, pageSize: pageSizeUserApply, }, continuousFn }).then(res => {
      const { list } = res.data
      let listTemp = []
      if (pageNoUserApply == 1) {
        listTemp = [].concat(list)
      } else {
        listTemp = [].concat(this.data.UserApplyList, list)
      }
      console.log(listTemp)
      this.setData({ UserApplyList: listTemp, pageNoUserApply: UserApplyList.length == pageSizeUserApply ? pageNoUserApply + 1 : pageNoUserApply, isAll: UserApplyList.length < pageSizeUserApply })

      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },
})

