// president/pages/ pavilion_record/ pavilion_record.js
import { routers, viewImage, sharePage, isFn, getGlobalVal } from '../../../utils/util.js'
import { VipSignInfoList } from '../../../utils/api.js'
const { navigateTo, redirectTo, navigateBack } = routers()
const { globalData, hasLibraryService, hasVipService } = getApp()
const { baseImgUrl, qrcodeInvalidToastText } = globalData

Page({
  data: {
    year: 0,
    month: 0,
    date: ['日', '一', '二', '三', '四', '五', '六'],
    dateArr: [],
    isToday: 0,
    user_vipId: '',
    isTodayWeek: false,
    todayIndex: 0,
    signMonth: '',
    nowdaydate:'',
    MumbersignList:[],
    signTimeList:[],
    nodataArray: {
      text: '本日无到馆记录',
      image: '../../../assets/Norecord.png'
    }
  },
  onLoad: function (options ) {
    const user_vipId = wx.getStorageSync("vipId")
    this.setData({
      user_vipId: user_vipId
    });
    wx.setNavigationBarTitle({
      title: `到馆记录`,
    })
    this.GetMonthDate()
    let now = new Date();
    let year = now.getFullYear();
    let month = now.getMonth() + 1;
    options.libId = getGlobalVal('list').length > 0 ? getGlobalVal('list')[0].libId : ''
    this.setData(options)
    this.getData(res => {
      this.setData({ isLoaded: 1 })
      this.dateInit();
    })
    this.setData({
      year: year,
      month: month,
      isToday: '' + year+'/' + month+'/' + now.getDate()
      
    })
  },

  dateInit: function (setYear, setMonth) {
    //全部时间的月份都是按0~11基准，显示月份才+1
    const { MumbersignList } = this.data  // 后台返回签到详情信息
    let dateArr = [];                       //需要遍历的日历数组数据
    let arrLen = 0;                         //dateArr的数组长度
    let now = setYear ? new Date(setYear, setMonth) : new Date();
    let year = setYear || now.getFullYear();
    let nextYear = 0;
    let month = setMonth || now.getMonth();                 //没有+1方便后面计算当月总天数
    let nextMonth = (month + 1) > 11 ? 1 : (month + 1);
    let startWeek = new Date(year + '/' + (month + 1) + '/' + 1).getDay();                          //目标月1号对应的星期
    let dayNums = new Date(year, nextMonth, 0).getDate();               //获取目标月有多少天
    let obj = {};
    let num = 0;
    if (month + 1 > 11) {
      nextYear = year + 1;
      dayNums = new Date(nextYear, nextMonth, 0).getDate();
    }
    arrLen = startWeek + dayNums;
    for (let i = 0; i < arrLen; i++) {
      if (i >= startWeek) {
        num = i - startWeek + 1;
        obj = {
          isToday: '' + year+'/' + (month + 1) +'/'+ num,
          dateNum: num,
          weight: 5,
          hasData: MumbersignList.length>0?MumbersignList[i - startWeek].hasData:'',
          signList: MumbersignList.length>0?MumbersignList[i - startWeek].signList:'',
        }
      } else {
        obj = {};
      }
      dateArr[i] = obj;
      console.log()
    }
    this.setData({
      dateArr: dateArr
    })
    console.log(dateArr)
    let nowDate = new Date();
    let nowYear = nowDate.getFullYear();
    let nowMonth = nowDate.getMonth() + 1;
    let nowDay = now.getDate(); 
    let nowWeek = nowDate.getDay();
    let getYear = setYear || nowYear;
    let getMonth = setMonth >= 0 ? (setMonth + 1) : nowMonth;
    if (nowYear == getYear && nowMonth == getMonth) {
      this.setData({
        isTodayWeek: true,
        todayIndex: nowWeek
      })
    } else {
      this.setData({
        isTodayWeek: false,
        todayIndex: -1
      })
    }
    for (let i = 0; i < dateArr; i++) {
      if (dateArr[i].dateNum == nowDay) {
        this.setData({ signTimeList: dateArr[i].signList, })
        console.log('signTimeList' + signTimeList)
      }
    }

  },
  GetMonthDate: function () {
    const now = new Date();
    const year = now.getFullYear();      　　 //年
    var month = (now.getMonth() + 1).toString().padStart(2, '0');     //月 
    const day = now.getDate().toString().padStart(2, '0') ;            　　//日
    const nowdaydate = year + '-' + month + '-' + day  //月        
    const nowdate = year + '-' + month
    this.setData({ signMonth: nowdate, nowdaydate: nowdaydate })

  },
    /**
  * 查看签到签退时间详情
  */
  LookSignTimeInfo: function (e) {
 
    const { signtime, datenum, year, month } = e.currentTarget.dataset
    const isToday = '' + year + '/' + month + '/' + datenum
    const { signTimeList } = this.data
    this.setData({ signTimeList: signtime, isToday: isToday })
  },

  /**
  * 获取会员到馆详情
  */
  getData: function (cb) {
    const continuousFn = { fn: this.getData, param: { ...arguments } }
    const { user_vipId, signMonth, libId, nowdaydate } = this.data
    VipSignInfoList({ data: { vipId: user_vipId, signMonth, libId }, continuousFn }).then(res => {
      const { list } = res.data;
      this.setData({ MumbersignList: list })
      for (let i = 0; i < list.length; i++) {
        var date1 = new Date(list[i].signDate);
        var date2 = new Date(nowdaydate);
        if (date1 - date2 == 0) {
          this.setData({ signTimeList: list[i].signList||[] })
        } 
      }
      cb && cb(res)
    }).catch(res => {
      cb && cb(res)
    })
  },
  /**
   * 上月切换
   */
  lastMonth: function () {
    //全部时间的月份都是按0~11基准，显示月份才+1
    const now = new Date();
    let year = this.data.month - 2 < 0 ? this.data.year - 1 : this.data.year;
    let month = this.data.month - 2 < 0 ? 11 : this.data.month - 2;
    let vipsignMonth = (month + 1).toString().padStart(2, '0'); 
    const { signTimeList } = this.data
    this.setData({ signTimeList: [], })   
    const nowdate = year + '-' + vipsignMonth
    this.setData({ signMonth: nowdate })
    this.setData({
      year: year,
      month: (month + 1)
    })
    this.getData(res => {
      this.setData({ isLoaded: 1 })
      this.dateInit(year, month);
    })
  },
  /**
   * 下月切换
   */
  nextMonth: function () {
    //全部时间的月份都是按0~11基准，显示月份才+1
    let year = this.data.month > 11 ? this.data.year + 1 : this.data.year;
    let month = this.data.month > 11 ? 0 : this.data.month;
    let vipsignMonth = (month + 1).toString().padStart(2, '0');
    const { signTimeList } = this.data
    const nowdate = year + '-' + vipsignMonth
    this.setData({ signMonth: nowdate })
    this.setData({
      year: year,
      month: (month + 1)
    })
    this.setData({ signTimeList: [], })
    this.getData(res => {
      this.setData({ isLoaded: 1 })
      this.dateInit(year, month);
    })
  }
})