import { fetch, uploadFile } from './util.js'

const fetchFn = url => paras => fetch(Object.assign({ url }, paras))
const uploadFileFn = url => paras => uploadFile(Object.assign({ url }, paras))

// 上传图片资源
export const UploadFile = uploadFileFn('/wxapi/images/uploadForm')

// 验证token是否失效
// export const CheckToken = fetchFn('/wxapi/user/checkToken')

// 小程序普通登录
export const WxLogin = fetchFn('/wxapi/user/readingLogin')

// 小程序首次登录
export const FirstWxLogin = fetchFn('/wxapi/user/newReadingLogin')

// 获取家长端我的首页
export const GetMineInfo = fetchFn('/wxapi/reading/mine')

// 获取家长端我的个人资料
export const GetVipInfo = fetchFn('/wxapi/reading/vipInfo')

// 保存个人资料信息
export const SaveVipInfo = fetchFn('/wxapi/reading/saveLibVip')

// 获取图书馆
export const GetLibrary = fetchFn('/wxapi/reading/positionJoin')

// 根据馆定位获取学校信息
export const GetpositionArea = fetchFn('/wxapi/reading/positionArea')
// 获取家长端首页
export const GetParentHome = fetchFn('/wxapi/reading/goodbook')

// 判断还可以借用多少本书
export const GetBorrowBookNum = fetchFn('/wxapi/reading/lendingTimes')

// 扫一扫借书
// export const ScanningBooks = fetchFn('/wxapi/reading/scanningBooks')

// 图书详情借阅，预约，心愿，添加
export const AddWishBooks = fetchFn('/wxapi/reading/addWish')

// 获取图书详情
export const GetBookDetail = fetchFn('/wxapi/reading/bookIsbnDetail')

// 获取借阅书籍
export const GetBorrowBook = fetchFn('/wxapi/reading/haveToBorrow')

// 借阅书籍
export const BorrowBook = fetchFn('/wxapi/reading/confirmBorrowing')

// 获取好书推荐列表
export const GetBookRecommend = fetchFn('/wxapi/reading/bookRecommend')

// 获取成长记录列表
export const GetGrowthRecord = fetchFn('/wxapi/reading/growthRecord')

// 获取常见问题列表
export const GetQuestion = fetchFn('/api/problem/list')

// 我要预约
export const ToReservation = fetchFn('/wxapi/reading/woYaoReservation')

// 全部预约
export const AlreadyReservation = fetchFn('/wxapi/reading/alreadyReservation')

// 搜索
export const SearchIndex = fetchFn('/wxapi/reading/searchIndex')

// 图书列表
export const SearchBookList = fetchFn('/wxapi/reading/bookList')

// 主题搜索
export const ThemeSearch = fetchFn('/wxapi/reading/themeSearch')

// 我的心愿书籍
export const MyWishBook = fetchFn('/wxapi/reading/myWish')

// 其他心愿书籍
export const OthersWishBook = fetchFn('/wxapi/reading/othersWish')

// 心愿助力
export const WishHelp = fetchFn('/wxapi/reading/wishHelp')

// 心愿详情
export const WishBookDetail = fetchFn('/wxapi/reading/wishDetails')


// 调度馆
export const DispatcherIndex = fetchFn('/wxapi/reading/dispatcherIndex')

// 确认拒绝调度员
export const DispatcherAudit = fetchFn('/wxapi/reading/dispatcherAudit')

// 获取带书入馆
// export const GetDispatchGo = fetchFn('/wxapi/reading/libDispatching')

// 获取图书列表
export const GetSweepedBooks = fetchFn('/wxapi/reading/scanBookList')

// 删除图书列表
export const DeleteSweepedBooks = fetchFn('/wxapi/reading/deleteBooks')

// 扫书入馆
export const DispatcherScanning = fetchFn('/wxapi/reading/dispatcherScanning')

// 提交送书到馆
export const ConfirmToLib = fetchFn('/wxapi/reading/confirmToLib')

// 提交带书离馆
export const ConfirmToZb = fetchFn('/wxapi/reading/confirmToZb')

// 调度员信息
export const GetDispatcherInfo = fetchFn('/wxapi/reading/dispatcherInfo')

// 获取撤馆列表
export const GetWithdrawLibrary = fetchFn('/wxapi/reading/cancelLibList')

// 获取所撤馆信息
export const GetWithdrawLibraryDetail = fetchFn('/wxapi/reading/cancelLibBookInfo')

// 确定撤馆 
export const ComfirmWithdrawLibrary = fetchFn('/wxapi/reading/cancelComfirm')

// 获取撤馆图书列表头部
export const GetRecoveryListHeadInfo = fetchFn('/wxapi/reading/cancelLibHeadInfo')

// 获取撤馆图书列表
export const GetRecoveryList = fetchFn('/wxapi/reading/recoveryList')

// 回收入库扫描书籍详情
export const DispatcherRecovery = fetchFn('/wxapi/reading/dispatcherRecovery')

// 确认收入或者入库
export const ConfirmRecovery = fetchFn('/wxapi/reading/confirmRecovery')


// 图书调度员--根据扫码二维码获取书籍信息 (新增)
export const ScanForBookDetail = fetchFn('/wxapi/reading/scanForBookDetail')

// 图书调度员--解绑图书 (新增)
export const RemoveBookLib = fetchFn('/wxapi/reading/removeBookLib')

// 图书调度员--归还图书 (新增)
export const BackBookLib = fetchFn('/wxapi/reading/backBookLib')


// 书籍详情
export const BookDetailView = fetchFn('/wxapi/readingcurator/bookDetailView')

// 获取校长端首页头部
export const GetBooksTab = fetchFn('/wxapi/readingcurator/bookstab')

// 书籍搜索列表Top10
export const GetLibraryTopTen = fetchFn('/wxapi/readingcurator/libraryTopTen')

// 获取校长端首页数据
export const GetBooksInlibrary = fetchFn('/wxapi/readingcurator/booksinthelibrary')

// 调入书籍
export const CallInBooks = fetchFn('/wxapi/readingcurator/callInBooks')

// 调出书籍
export const CallOutBooks = fetchFn('/wxapi/readingcurator/callOutBooks')

// 调出
export const CallOutList = fetchFn('/wxapi/readingcurator/callOutList')

// 调入
export const CallInList = fetchFn('/wxapi/readingcurator/callInList')

// 删除书籍
export const DeleteBooks = fetchFn('/wxapi/readingcurator/deleteBooks')

// 锁定库存
export const SaveLocking = fetchFn('/wxapi/readingcurator/saveLocking')

// 获取校长主题系列书籍
// export const GoodBooksToRead = fetchFn('/wxapi/readingcurator/goodBooksToRead')

// 获取部分调入图书
export const GetThemeAllBook = fetchFn('/wxapi/readingcurator/themeAll')

// 确认调入
export const BatchCallInBooks = fetchFn('/wxapi/readingcurator/batchCallInBooks')

// 提交申请书单
export const PostApplyBookList = fetchFn('/wxapi/readingcurator/postApplyBookList')

// 找好书2.0
// 好书推荐(20191010修改)
export const GoodBooksToRead = fetchFn('/wxapi/readingcurator/goodBooksToRead')

// 随机选书提交(2019-10-10)
export const RandomBook = fetchFn('/wxapi/readingcurator/randomBook')

// 好书推荐搜索(2019-10-10)
export const GoodBooksSearch = fetchFn('/wxapi/readingcurator/goodBooksSearch')

// 家长端迭代
// 首页
export const GoodIndex = fetchFn('/wxapi/reading/parent/goodIndex')
// 找好书搜索
export const GoodIndexSearch = fetchFn('/wxapi/reading/parent/goodIndexSearch')
// 搜索历史
export const IndexSearchHis = fetchFn('/wxapi/reading/parent/indexSearchHis')
// 清除搜索历史
export const ClearSearchHis = fetchFn('/wxapi/reading/parent/clearSearchHis')
// 书籍详情
// export const BookDetailView = fetchFn('/wxapi/reading/parent/bookDetailView')
// 图书分类
export const BookSort = fetchFn('/wxapi/reading/parent/bookSort')
// 初始化借阅车
export const InitBorrowCar = fetchFn('/wxapi/reading/parent/initBorrowCar')
// 扫码书籍加入借阅单
export const ScanningBooksTwo = fetchFn('/wxapi/reading/parent/scanningBooks')
// 首页滚动栏
export const IndexBarList = fetchFn('/wxapi/reading/parent/IndexBarList')
// 定位获取图书馆信息
export const PositionJoin = fetchFn('/wxapi/reading/parent/positionJoin')
// 确定借阅
export const ConfirmBorrow = fetchFn('/wxapi/reading/parent/confirmBorrow')
// 借阅记录
export const BorrowInfoList = fetchFn('/wxapi/reading/parent/borrowInfoList')
// 主题借阅记录
export const ThemeBorrowedList = fetchFn('/wxapi/reading/parent/themeBorrowedList')
// 馆内当前排名
export const UserRankingLib = fetchFn('/wxapi/reading/parent/userRankingLib')
// 馆内历史排名
export const LibRankingHis = fetchFn('/wxapi/reading/parent/libRankingHis')
// 成长轨迹
export const UserReadInfo = fetchFn('/wxapi/reading/parent/userReadInfo')
// 提交申请书单
export const ApplyBook = fetchFn('/wxapi/reading/parent/applyBook')
// 申请书单记录
export const ApplyBookHis = fetchFn('/wxapi/reading/parent/applyBookHis')
// 图书分类查询
export const SortSearch = fetchFn('/wxapi/reading/parent/sortSearch') 



// 馆长端迭代
// 签到签离列表
export const SignList = fetchFn('/wxapi/readingcurator/signList')
// 签到签离提交
export const SignSubmit = fetchFn('/wxapi/readingcurator/signSubmit')
// 数据统计-日统计
export const DayCount = fetchFn('/wxapi/readingcurator/dayCount')
// 数据统计-月统计
export const MonthCount = fetchFn('/wxapi/readingcurator/monthCount')
// 本月到馆人数列表
export const SignMonthList = fetchFn('/wxapi/readingcurator/signMonthList')
// 本月到馆人数列表
export const DayInfoList = fetchFn('/wxapi/readingcurator/dayInfoList')
// 代办借阅会员列表
export const AgencyVipList = fetchFn('/wxapi/readingcurator/agencyVipList') 
// 馆内排行榜
export const RankingLib = fetchFn('/wxapi/readingcurator/rankingLib')
// 借阅记录
export const ReadingBorrowInfoList = fetchFn('/wxapi/readingcurator/borrowInfoList')
// 会员管理列表
export const LibVipList = fetchFn('/wxapi/readingcurator/libVipList')
// 会员管理列表
export const ManagerList = fetchFn('/wxapi/readingcurator/managerList')
// 人员搜索
export const LibSearch = fetchFn('/wxapi/readingcurator/libSearch')
// 会员管理详情
export const VipDetailInfo = fetchFn('/wxapi/readingcurator/vipDetailInfo')
// 修改会员服务有效期
export const EditVipservice = fetchFn('/wxapi/readingcurator/editVipservice')
// 会员个人信息详情
export const VipInfo = fetchFn('/wxapi/readingcurator/vipInfo')
// 保存个人信息详情
export const ReadingAaveVipInfo = fetchFn('/wxapi/readingcurator/saveVipInfo')
// 会员到馆详情
export const VipSignInfoList = fetchFn('/wxapi/readingcurator/vipSignInfoList')
// 馆内人员信息编辑
export const ManagerEdit = fetchFn('/wxapi/readingcurator/managerEdit')
// 馆内人员信息保存
export const ManagerSave = fetchFn('/wxapi/readingcurator/managerSave')
// 删除馆内人员
export const ManagerDel = fetchFn('/wxapi/readingcurator/managerDel')
// 调书申请记录
export const ApplyInfoList = fetchFn('/wxapi/readingcurator/ApplyInfoList')
// 调书申请明细记录
export const ApplyInfoDetailList = fetchFn('/wxapi/readingcurator/ApplyInfoDetailList')
// 新书申请记录
export const NewBookApplyInfoList = fetchFn('/wxapi/readingcurator/NewBookApplyInfoList')
// 新书申请明细记录
export const NewBookApplyDetailList = fetchFn('/wxapi/readingcurator/NewBookApplyDetailList')
// 确定还书
export const ConfirmBackBorrow = fetchFn('/wxapi/readingcurator/confirmBackBorrow')
// 获取角色信息
export const CheckRole = fetchFn('/wxapi/readingcurator/checkRole')
// 扫码书籍加入还书车
export const ScanningBackBooks = fetchFn('/wxapi/readingcurator/scanningBackBooks')
// 在馆书籍主题年段详情
export const BookInLibInfo = fetchFn('/wxapi/readingcurator/bookInLibInfo')

// 录入识别二维码是否有效
export const CheckBookCard = fetchFn('/wxapi/readingcurator/checkBookCard')
// 根据isbn13查询书籍信息
export const GetBookInfoByIsbn = fetchFn('/wxapi/readingcurator/getBookInfoByIsbn')
// 录书保存
export const AddBook = fetchFn('/wxapi/readingcurator/addBook')
// 根据id获取书籍信息完善书架
export const BookCase = fetchFn('/wxapi/readingcurator/bookCase')
// 保存书架信息
export const SaveBookcase = fetchFn('/wxapi/readingcurator/saveBookcase')
// 保存书架信息
export const ReadinglibRankingHis = fetchFn('/wxapi/readingcurator/libRankingHis')
// 催还书籍提交
export const CallBookBack = fetchFn('/wxapi/readingcurator/callBookBack')
// 馆内人员添加搜索
export const LibManagerSearch = fetchFn('/wxapi/readingcurator/libManagerSearch')
// 馆内人员添加搜索
export const SearchUserApplyList = fetchFn('/wxapi/readingcurator/userApplyList')

// 馆内人员添加搜索
export const CheckNext = fetchFn('/wxapi/readingcurator/checkNext')
// 关于私塾家
export const AboutSharingSchool = fetchFn('/api/problem/aboutSharingSchool')

